<?php
require_once './config/defaults.php';
require_once "./locale/$default->language/topbar.lang";
require_once './lib/constants.php';
require_once './lib/common_functions.php';
require_once "./lib/db_$default->database_driver.php";
require_once "./locale/$default->language/admin.lang";

$sec->check_auth($authenticated);

//See if they are logging back in after using someone else's account
if (session_is_registered('old_user')) {
    //Login as the user the adminstrator specifies
    $_SESSION['user_name'] = $user_name = $old_user;
    session_unregister('old_user');
    //Bring them back in
    header ('Location: admin.php');
}
$motdFilename = 'config/MOTD.html';

//Make sure they are an admin
$_verifiedAdmin = false;
foreach ($default->administrators as $admin) {
    if ($user_name == $admin) {
        $_SESSION['_verifiedAdmin'] = $_verifiedAdmin = true;
    }
}
if (!$_verifiedAdmin) {
    header('Location: login.php?actionID='.LOGIN_LOGOUT);
}
if ($default->auth_method == 'db') {
    // select list of all users
    $userSelect = oats_get_user_select();
}

if ($actionID == 'add_faq') {
    if (!empty($question) && !empty($answer)) {
        //Delete it first in case they are updating
        $result = oats_delete_faq($faqID);
        check_success($result, 'database_error');
        $question = str_replace("'", '', $question);
        $answer = str_replace("'", '', $answer);
        $result = oats_add_faq(addslashes($question),addslashes(nl2br($answer)));
        check_success($result, 'database_error');
        $lang->message = $lang->faq_added;
    } else {
        $lang->message = $lang->admin_welcome;
    }
} elseif ($actionID == 'delete_faq') {
    $result = oats_delete_faq($faqID);
    check_success($result, 'database_error');
    $lang->message = $lang->faq_deleted;
} elseif ($actionID == 'delete_user') {
    $result = oats_delete_user($_POST['user_del_name']);
    check_success($result, 'database_error');
    $lang->message = sprintf($lang->user_deleted, $_POST['user_del_name']);
    // re-generate select
    $userSelect = oats_get_user_select();
} elseif ($actionID == 'update_motd') {
    $fd = fopen ($motdFilename, 'w');
    fwrite ($fd, stripslashes($motd));
    fclose ($fd);
    $lang->message = $lang->motd_updated;
} elseif ($actionID == 'delete_jobs') {
    $result = oats_delete_all($default->db_jobs_table);
    $lang->message = "$default->db_jobs_table $lang->was_emptied";
} elseif ($actionID == 'delete_personal') {
    $result = oats_delete_all($default->db_personal_table);
    $lang->message = "$default->db_personal_table $lang->was_emptied";
} elseif ($actionID == 'delete_time') {
    $result = oats_delete_all($default->db_time_table);
    $lang->message = "$default->db_time_table $lang->was_emptied";
} elseif ($actionID == 'delete_users') {
    $result = oats_delete_all($default->db_users_table);
    $lang->message = "$default->db_users_table $lang->was_emptied";
} elseif ($actionID == 'login_new') {
    //Login as the user the adminstrator specifies
    $_SESSION['old_user'] = $user_name;
    $_SESSION['user_name'] = $new_user;
    //redirect to login page
    header ('Location: timecard.php');
} else {
    $lang->message = $lang->admin_welcome;
}

//Load in MOTD
$motd = htmlentities(stripslashes(join('',file($motdFilename))));

$faqs = oats_get_faq();
include_once './templates/common-header.inc.php';
include_once './templates/topbar/topbar.inc.php';
include_once './templates/admin/admin.inc.php';
include_once './templates/common-footer.inc.php';
?>
