<?php
require "./config/defaults.php";
require "./locale/$default->language/topbar.lang";
require "./lib/constants.php";
require "./lib/common_functions.php";
require "./locale/$default->language/jobs.lang";
require "./lib/db_$default->database_driver.php";

//Check to make sure they are logged in
$sec->check_auth($authenticated);

include "./templates/common-header.inc.php";
include "./templates/topbar/topbar.inc.php";

if ($actionID == "submit") {
	if (!check_email($supervisor_email)) {
		$job_details = oats_get_job_details($user_name, $default->server, addslashes($job_name));
		check_success($job_details, "database_error");
                $lang->update_job = $lang->invalid_email;
		$build_form = true;
	}elseif (!$job_name) {
		$lang->update_job = $lang->no_job_name;
		$build_form = true;
	} else {
		//Strip out punctuation and spaces in $account_num
		$account_num = ereg_replace("[[:punct:]]*[[:space:]]*", "", $account_num);
		//Insert values into database
		$insert = oats_update_job($user_name, $default->server, addslashes($job_name), addslashes($account_num), addslashes($supervisor), addslashes($supervisor_email), addslashes($department), addslashes($employment_type), $fill_in_hours, addslashes($payrate));
		check_success($insert, "database_error");
		//Retrieve all the jobs a user has
		$jobs = oats_get_jobs ($user_name, $default->server);
		check_success($jobs, "database_error");
	}
} elseif ($actionID == "update" || $actionID == "add") {
	if ($actionID == "update") {
		$job_details = oats_get_job_details($user_name, $default->server, addslashes($job_name));
		check_success($job_details, "database_error");
	} else { //They're adding a job
		$lang->update_job = $lang->add_job;
	}
	$build_form = true;
} elseif ($actionID == "delete") {
	$del = oats_delete_job ($user_name, $default->server, addslashes($job_name));
	check_success($del, "database_error");
	$jobs = oats_get_jobs ($user_name, $default->server);
	check_success($jobs, "database_error");
	$lang->jobs_updated = $lang->job_deleted;
} else { 
	//Retrieve all the jobs a user has
	$jobs = oats_get_jobs ($user_name, $default->server);
	check_success($jobs, "database_error");
	$lang->jobs_updated = $lang->my_jobs;
}

if ($build_form) {
	//Build form
	include "./templates/jobs/begin.inc.php";
	include "./templates/jobs/job_name.inc.php";
	include "./templates/jobs/account_num.inc.php";
	include "./templates/jobs/supervisor.inc.php";
	if ($default->user_use_sup_email) { include "./templates/jobs/supervisor_email.inc.php"; }
	include "./templates/jobs/department.inc.php";
	if ($default->user_use_emp_type) { include "./templates/jobs/employment_type.inc.php"; }
	include "./templates/jobs/fill_in_hours.inc.php";
	include "./templates/jobs/payrate.inc.php";
	include "./templates/jobs/end.inc.php";
} else {
	include "./templates/jobs/show_jobs.inc.php";
}

include "./templates/common-footer.inc.php";

?>
