<?php
class Security {

  function authenticate ($user, $pass, $auth_method) {
    global $default, $authenticated;
   
    //Start out false
    $auth_result = false;
    if ($auth_method == 'imap' || $auth_method == 'pop3') {
      if ($auth_method == 'pop3') {
        $connstr = '{' . $default->server . ':' . $default->port . '/pop3}';
      } else { // default to imap connections
        $connstr = '{' . $default->server . ':' . $default->port . '}';
      }
      $auth_result = @imap_open($connstr, $user, $pass);
      //Close auth_result since we don't need it anymore
      @imap_close($auth_result);
    }
    elseif ($auth_method == 'db') {
        $auth_result = oats_validate_user($user, $pass);
    }
    
    if (!$auth_result) {
      $this->invalidLogin();
    } else {
      //Now they're authenticated for the session
      $this->start_sess();
      $_SESSION[PRIMARY_VAR] = $user;
      $_SESSION[AUTHENTICATED_VAR] = true;
      $this->successfulLogin();
    }
  } // authenticate()

  function invalidLogin () {
    //Never started a session, so we don't have to end one
    header("HTTP/1.0 301");
    header("Location: " . INVALID_LOGIN_PAGE);
    exit;
  } // invalidLogin()

  function successfulLogin () {
    header("HTTP/1.0 301");
    $location = $this->addSessToLink(SUCCESS_LOGIN_PAGE); 
    header("Location: $location");
    exit;
  } // successfulLogin()

  function start_sess () {
    global $default;
    session_name($default->sess_name);
    session_start();
  } // register_sess()

  function end_sess () {
    //Just in case, set authenticated to false
    $GLOBALS['HTTP_SESSION_VARS'][AUTHENTICATED_VAR] = false;
    //Have to destroy the cookies since PHP's function is unreliable
    $p = session_get_cookie_params();
    setcookie(session_name(), "", time() - 3600, $p["path"], $p["domain"]);
    session_destroy();
  } // end_sess()

  function register_variables ($val) {
    if (is_array($val)) {
      reset($val);
      while (list ($k, $v) = each ($val)) {
	    session_register($v);
      } 
    } else { //It's just a single variable
    	    session_register($val);
    }
  } 

  function addSessToLink ($link) {
    //For HTML encoded variables
    $link = ereg_replace("%", "%%", $link);
    //If link alread has variables
    if (ereg("\?", $link)) {
        $newlink = sprintf ($link . '&%s',SID);
    } else {
        $newlink = sprintf ($link . '?%s',SID);
    }
    return $newlink;
  } // addSessToLink()

  function check_auth ($auth) {
  	//If they're not authenticated, send them to log in page
  	if (! isset($auth) || ! $auth) {
	    header("HTTP/1.0 301");
	    header("Location: " . INVALID_LOGIN_PAGE);
	    exit;
	}
  } // check_auth()

} //end class Security
?>
