<?php
/* Functions used in OATS */

function print_start_dates ($user_start) {
  global $default;

  reset ($default->startdates);
  $size = sizeof($default->startdates);
  --$size;
  while (list ($key, $start_date) = each ($default->startdates)) {
    //If it's the last date, we have to use ther variable to determine length of period
    if ($key == $size) {
      $num_days = $default->num_in_last;
    } else {
      $num_days = calculate_days($default->startdates[$key],$default->startdates[$key + 1]);
    }
    $num_days--;

    $date_parts = explode("/", $start_date);
    //Make the ending date
    $end_date = date("m/d/Y", mktime(0,0,0,$date_parts[0],$date_parts[1] + $num_days,$date_parts[2]));
    //Get the unix dates in order to calculate which one should be selected
    $unix_start = mktime(0,0,0,$date_parts[0],$date_parts[1],$date_parts[2]);
    $today = getdate();
    $unix_date = mktime(0,0,0,$today['mon'], $today['mday'], $today['year']); 
    $date_parts = explode("/", $end_date);
    $unix_end = mktime(0,0,0,$date_parts[0],$date_parts[1],$date_parts[2]);

    $selected = "";
    //See if we should select the user's last selected start date
    if (!empty($user_start) && $user_start == $unix_start) {
      $selected = " selected=\"selected\"";
    }
    if ($unix_date >= $unix_start && $unix_date <= $unix_end) {
      //Otherwise just select current date
      if (empty($user_start)) {
        $selected = " selected=\"selected\"";
      }
      //determine days left in time period for alert box
      $tmp = $unix_end - $unix_date;
      $days_left = date("d", $tmp);
    }
    echo "<option value='$start_date-$num_days'$selected>$start_date - $end_date</option>\n";
  }
  return $days_left;
} //print_start_dates()

function print_col_labels ($submittc = false, $text_version = false) {
  global $lang, $default;
  //Print column labels
  if ($text_version) { 
    $return_string = "\t\t";
  } else {
    echo "<tr><td>&nbsp;</td>"; 
  }
  for ($col_label = 1; $col_label <= $default->num_of_inouts; $col_label++) {
    if ($text_version) {
      $return_string .= "$lang->time_in ($col_label)  $lang->time_out ($col_label)  ";
    } else {
      echo "<td bgcolor=$default->in_out_color align=center><b>$lang->time_in ($col_label)</b></td>\n";
      echo "<td bgcolor=$default->in_out_color align=center><b>$lang->time_out ($col_label)</b></td>\n";
    }
  }  
  if ($submittc) {
    if ($text_version) {
      $return_string .= "\t$lang->total_hours";
    } else {
      echo "<td bgcolor=\"$default->in_out_color\" align=\"center\" nowrap=\"nowrap\"><b>$lang->total_hours</b></td>\n";
    }
    if ($default->calculate_overtime) {
      if ($text_version) {
	$return_string .= "\t$lang->ot_hours";
      } else {
	echo "<td bgcolor=\"$default->in_out_color\" align=\"center\" nowrap=\"nowrap\"><b>$lang->ot_hours</b></td>\n";
      }
    }
    if ($default->calculate_breaks) {
      if ($text_version) {
	$return_string .= "\t$lang->breaks";
      } else {
	echo "<td bgcolor=\"$default->in_out_color\" align=\"center\" nowrap=\"nowrap\"><b>$lang->breaks</b></td>\n";
      }
    }
  }
  if ($text_version) { return ("$return_string\n"); } else { echo "</tr>\n"; }
} //print_col_labels()

function print_week ($week, $cols, $text_version = false) {
  global $lang, $default;
  if ($text_version) {
    $return_string = "\n";
    for ($i = 1;$i <= ($cols/2); $i++) {
      $return_string .= "\t";
    }
    $return_string .= "$lang->week $week\n\n";
    return ($return_string);
  } else {
    echo "<tr><td colspan=$cols align=center><span class='header'>$lang->week $week</span></td></tr>\n";
  }
} //print_week()

function print_day ($unix_date, $job, $clock_in_out = false, $submittc = false, $text_version = false) {
  global $default, $user_name, $lang;

  //If it's the text version we don't want output
  if ($text_version) { ob_start(); }

  //Display day name and date
  $display_date = date("D. (m/d)", $unix_date);
  echo "<tr>\n";
  //Make it a different color if it is a weekend
  if (ereg("^S", $display_date)) {
    echo "<td bgcolor=$default->weekend_color valign=\"center\" align=\"center\" nowrap>\n";
  }else { echo "<td bgcolor=$default->weekday_color valign=\"center\" align=\"center\" nowrap>\n"; }
  if ($text_version) {
    $text_string = "$display_date\t";
  } else {
    echo "<b>$display_date</b>\n";
  }
  echo "</td>\n";

  $time_data = oats_get_times($user_name,$default->server,$unix_date,addslashes($job));
  check_success($time_data,"database_error");

  //Add up times if they are submitting
  if ($submittc) {
    $total = add_up_minutes($time_data);
    //Calculate number of breaks
    if ($default->calculate_breaks) {
      if ($total >= 210 && $total <= 359) {
        $num_breaks = 1;
      } elseif ($total >= 360 && $total <= 599) {
        $num_breaks = 2;
      } elseif ($total >= 600 && $total <= 839) {
        $num_breaks = 3;
      } elseif ($total >= 840) {
        $num_breaks = 4;
      } else {
        $num_breaks = 0;
      }
    }
    //Check for start time, but no end time
    if ($total < 0) { 
      $show_negative = true;
    } else {
      //Add up overtime if specified
      if ($default->calculate_overtime) {
        $ot_hours = calculate_overtime($total, "day");
	//Subtract ot_hours from regular total time (ot_hours is 0 if there was no overtime)
	$total -= $ot_hours;
      }
      $total = minutes_to_24($total);
    }
  }

  usort($time_data,"compare_sequence");
  //Take out the success tag
  array_shift($time_data);
  $array_key = 0;
  //In case there are no times to fill it
  settype($time, "array");

  //Display all the input boxes
  for ($col = 0; $col < $default->num_of_inouts; ++$col) {
    //do it for both in and out
    //in is 0, out is 1
    for ($i = 0; $i < 2; $i++) {
      if (isset($time_data[$array_key]['minutes'])) {
        $time = minutes_to_hours($time_data[$array_key]['minutes']);
      }
      $array_key++;

      //If it is a clock in or out, fill in current time into first empty box
      if ($clock_in_out && empty($time['hour']) && empty($time['minutes']) && !$already_filled) {
        $time['hour'] = date("g");
	$time['minutes'] = date("i");
	$time['ampm'] = date("a");
	$already_filled = true;
      }
      
      //All data is in multidimensional array: $tcdata[date][col][inout][val]

      echo "<td valign=\"center\" bgcolor=" . $default->tc_color[$col] . ">\n";
      //If submitting a timecard only put the times, else put input boxes
      if ($submittc) {
        if (empty($time['hour']) && empty($time['minutes'])) {
	  //If doing text version, return tab delimted
	  if ($text_version) {
	    $text_string .= "\t";
	  } else { echo "&nbsp;"; }
	} else {
	  if ($text_version) {
	    $text_string .= $time['hour'] . ":" . $time['minutes'] . $time['ampm'] . "\t";
	  } else { echo $time['hour'] . ":" . $time['minutes'] . $time['ampm']; }
	}
      } else {
	echo "<table border=\"0\" cellpadding=\"0\" cellspacing=0><tr><td nowrap>\n";
	echo "<input type=\"text\" size=\"2\" maxlength=\"2\" value='" . $time['hour'] . "' name='tcdata[$unix_date][$col][$i][hour]'> <b>:</b> ";
	echo "<input type=\"text\" size=\"2\" maxlength=\"2\" value='" . $time['minutes'] . "' name='tcdata[$unix_date][$col][$i][minute]'>\n";
	echo "</td><td nowrap>\n";
	$ampm = array("am","pm");
	reset ($ampm);
	while (list ($k, $v) = each ($ampm)) {
	  echo "<input type=\"radio\" value='$v' name='tcdata[$unix_date][$col][$i][ampm]'"; 
	  if (strcmp($time['ampm'],$v) == 0) {
	    echo " checked=\"checked\"";
	  }
	  echo "><b>$v</b>\n";
	  if ($v == "am") {
	    echo "<br />";
	  }
	}
	echo "</td></tr></table>\n";
      }
      echo "</td>\n";
      unset($time);
    }
  } 
  if ($submittc) {
    //Check for negative hours
    if ($show_negative) {
      $output = $lang->negative_time . ASTERISK; 
    } else {
      $output =  $total['hour'] . ":" . $total['minutes'];
    }
    if ($text_version) {
      $text_string .= "\t$output";
    } else {
      echo "<td bgcolor=\"$default->in_out_color\" align=\"center\"><b>$output</b></td>";
    }
    //check for calculating overtime
    if ($default->calculate_overtime) {
      $output = minutes_to_24($ot_hours);
      $output =  $output['hour'] . ":" . $output['minutes'];
      if ($text_version) {
	$text_string .= "\t\t$output";
      } else {
	echo "<td bgcolor=\"$default->in_out_color\" align=\"center\"><b>$output</b></td>";
      }
    }
    //output number of required breaks
    if ($default->calculate_breaks) {
      if ($text_version) {
	$text_string .= "\t\t$num_breaks";
      } else {
        echo "<td bgcolor=\"$default->in_out_color\" align=\"center\"><b>$num_breaks</b></td>";
      }
    }
  }  
  $text_string .= "\n";
  echo "</tr>\n";

  //If it's the text version end output buffer 
  if ($text_version) { 
    ob_end_clean(); 
    return ($text_string); 
  }
} //print_day()

function compare_sequence ($a,$b) {
  //Put array in sequential order
  return ($a['sequence'] > $b['sequence']) ? 1 : -1;
} //compare_sequence()

function calculate_overtime($time, $period) {
  //Calculate overtime for a given time period 
  /* OT rules:
  day: if more than 8 hours it's overtime
  week: if more than 40 regular hours in a week, then it's OT
  */
  //Time should come in minutes
  $max_day = 480;
  $max_week = 2400;
  if ($period == "day" && $time > $max_day) {
    $ot = $time - $max_day;
  } elseif ($period == "week" && $time > $max_week) {
    $ot = $time - $max_week;
  } else {
    $ot = 0;
  }
  return $ot;
} //calculate_overtime()

function calculate_days ($start, $end) {
  //Calculate the number of days between two dates
  //Date is in form mm/dd/yyyy
  $unix_start = strtotime($start);
  $unix_end = strtotime($end);
  $num_days = (((($unix_end - $unix_start)/60)/60)/24);
  return round($num_days);
} //calculate_days

function process_data ($data, $user_name, $job_name, $job_details, $template = false) {
  global $default, $lang, $form_type;
  //All data is in multidimensional array: $tcdata[date][col][inout][val]
  reset ($data);
  $day_num = 0;
  //Each date
  while (list ($k1, $v1) = each ($data)) {
    reset ($data[$k1]);
    //Sequence of user's input
    $sequence = 0;
    //last column that there is user input
    $last_col = 0;
    //Each column
    while (list ($k2, $v2) = each ($data[$k1])) {
      reset ($data[$k1][$k2]);
      //Each inout
      while (list ($k3, $v3) = each ($data[$k1][$k2])) {
        //If no minutes are entered, replace with 0
        if (!empty($data[$k1][$k2][$k3]['hour']) && empty($data[$k1][$k2][$k3]['minute'])) {
          $data[$k1][$k2][$k3]['minute'] = "00";
        }
        if (!empty($data[$k1][$k2][$k3]['hour']) && !empty($data[$k1][$k2][$k3]['minute'])) {
	  //Replace any spaces, letters, or punctuation with nothing
	  $data[$k1][$k2][$k3]['hour'] = ereg_replace("[[:alpha:]]|[[:punct:]]|[[:space:]]", "", $data[$k1][$k2][$k3]['hour']);
	  $data[$k1][$k2][$k3]['minute'] = ereg_replace("[[:alpha:]]|[[:punct:]]|[[:space:]]", "", $data[$k1][$k2][$k3]['minute']);

          $minutes = hours_to_minutes($data[$k1][$k2][$k3]['hour'], $data[$k1][$k2][$k3]['minute'], $data[$k1][$k2][$k3]['ampm']);
          //Have to check if clock out is greater than clock in
          if ($k3 == 0 && !empty($data[$k1][$k2][1]['hour'])) {
            $out_minutes = hours_to_minutes($data[$k1][$k2][1]['hour'], $data[$k1][$k2][1]['minute'], $data[$k1][$k2][1]['ampm']);
	    //If ampm is not set and the out time is less than the in 
	    //time it should default to "pm", else it's "am"
	    if (($out_minutes < $minutes) && empty($data[$k1][$k2][1]['ampm'])) {
	      $data[$k1][$k2][1]['ampm'] = "pm";
	      //recalculate out_minutes
	      $out_minutes = hours_to_minutes($data[$k1][$k2][1]['hour'], $data[$k1][$k2][1]['minute'], $data[$k1][$k2][1]['ampm']);
	    }
          } else {
            //If it's not set then it should be high to be greater than clock in 
            $out_minutes = 5000;
          }
	  //Have to check that clock in #2 is later than previous clock out
          if ($k3 == 1 && !empty($data[$k1][$k2 + 1][0]['hour'])) {
            $next_minutes = hours_to_minutes($data[$k1][$k2 + 1][0]['hour'], $data[$k1][$k2 + 1][0]['minute'], $data[$k1][$k2 + 1][0]['ampm']);
          } else {
            //If it's not set then it should be high to be greater than clock out 
            $next_minutes = 5000;
          }
	    
	  if (!check_data($data[$k1][$k2][$k3]['hour'], $data[$k1][$k2][$k3]['minute'], $minutes, $out_minutes, $next_minutes)) {
	    $lang->template_success = "";
	    $return['date'] = $k1;
	    $return['col'] = $k2;
	    $return['inout'] = $k3;
	    $return['hour'] = $data[$k1][$k2][$k3]['hour'];
	    $return['minute'] = $data[$k1][$k2][$k3]['minute'];
	    $return['ampm'] = $data[$k1][$k2][$k3]['ampm'];
	    return $return;
	  }
	  ++$last_col;
	  $time[$sequence] = $minutes;
	}
        ++$sequence;
      }
    }
    //If we're making a template
    $day = ($template ? $day_num : $k1);
    $day_num++;

    $last_col /= 2;
    settype($last_col,"integer");
    $next_month = date("m", $k1 + SECONDS_IN_DAY);
    $next_day = date("d", $k1 + SECONDS_IN_DAY);
    $next_year = date("Y", $k1 + SECONDS_IN_DAY);
    $next_time = mktime(0,0,0,$next_month,$next_day,$next_year);
    //Check to see if they are clocking in at night and out the next morning
    //Only do this if they've entered at least one time and this is not the clock in/out form 
    if (!empty($data[$k1][0][0]['hour']) && !isset($clock_in_made[$k1]) && ($form_type != "clock_in_out") && ($job_details['fill_in_hours'] == "yes")) {
      //If they have a clock in time (but do not have a clock out) for today 
      //and no clock in or out time for the next day
      if (!empty($data[$k1][$last_col][0]['hour']) && empty($data[$k1][$last_col][1]['hour']) && empty($data[$next_time][0][0]['hour']) && empty($data[$next_time][0][1]['hour'])) { 
	//set out to 11:59pm
	$time[$sequence] = 1439;
	//if not set, then time in for next day is 12:00am
	$data[$next_time][0][0]['hour'] = 12;
	$data[$next_time][0][0]['minute'] = "00";
	$data[$next_time][0][0]['ampm'] = "am";
	//Set tag so a clock out time won't be set on the next loop
	$clock_in_made[$next_time] = true;
      }
    }

    //Check to see if they are clocking in at night and out the next day
    if (!empty($data[$k1][$last_col][0]['hour']) && empty($data[$k1][$last_col][1]['hour']) && empty($data[$next_time][0][0]['hour']) && !empty($data[$next_time][0][1]['hour']) && ($form_type != "clock_in_out")) {
      //set out to 11:59pm
      $time[$sequence] = 1439;
      //if not set, then time in for next day is 12:00am
      $data[$next_time][0][0]['hour'] = 12;
      $data[$next_time][0][0]['minute'] = "00";
      $data[$next_time][0][0]['ampm'] = "am";
    }
  
    //Delete all data for this day
    $success = oats_delete_times($user_name, $default->server,$day,addslashes($job_name));
    check_success($success, "database_error");
    //Now submit data for the entire day to the database
    if (is_array($time)) {
      reset ($time);
      while (list ($key, $val) = each ($time)) {
        $success = oats_insert_times($user_name, $default->server,$day,addslashes($job_name),$val, $key);
        check_success($success, "database_error");
      }
    }
    unset ($time); 
    $lang->result = $lang->input_success;
  }
  //True means there was an error
  return false;
} //process_data()

function check_data ($hour, $minute, $minutes, $out_minutes, $next_minutes) {
  global $lang;
  $success = true;
  //Check to make sure string is not too long
  if (strlen($hour) > 2 || strlen($minute) > 2) {
    $lang->result = $lang->bad_length; 
    $success = false;
  }
  if ($hour > 12) {
    $lang->result = $lang->bad_hour;
    $success = false;
  }
  if ($minute > 59) {
    $lang->result = $lang->bad_minute;
    $success = false;
  }
  if ($out_minutes <= $minutes) {
    $lang->result = $lang->bad_clockout;
    $success = false;
  }
  if ($next_minutes <= $minutes) {
    $lang->result = $lang->bad_next_time;
    $success = false;
  }

  return $success;
} //check_data()

function hours_to_minutes($hour, $min, $ampm) {
  //convert hh:mm am/pm to minutes
  if ($hour == 12 && $ampm == "am") {
    $hour = 0;
  } 
  //convert to 24 hour format
  if ($ampm == "pm" && $hour < 12) {
    $hour += 12;
  }

  $hour *= 60;
  $minutes = $hour + $min;
  return $minutes;
} //hours_to_minutes()

function minutes_to_hours($minutes) {
  //Return minutes in hh:mm am/pm
  if ($minutes < 720) {
    $time['ampm'] = "am";
  } else {
    $time['ampm'] = "pm";
  }

  $hour_decimal = $minutes / 60;
  $hour = $hour_decimal;
  settype($hour, "integer");
  $minutes = (($hour_decimal - $hour) * 60);
  $minutes = round($minutes);
  $minutes = sprintf("%02d", $minutes);

  if ($hour > 11) {
    $hour -= 12;
  }
  if ($hour == 0) {
    $hour = 12;
  }

  $time['minutes'] = $minutes;
  $time['hour'] = $hour;
  return $time;
} //minutes_to_hours()

function minutes_to_24($minutes) {
  //Return minutes in 24 hour format
  $hour_decimal = $minutes / 60;
  $hour = $hour_decimal;
  settype($hour, "integer");
  $minutes = (($hour_decimal - $hour) * 60);
  $minutes = round($minutes);
  $minutes = sprintf("%02d", $minutes);

  $time['minutes'] = $minutes;
  $time['hour'] = $hour;
  return $time;
} //minutes_to_24()

function add_up_minutes($minutes) {
  usort($minutes, "compare_sequence");
  //Take out the success tag
  array_shift($minutes);
  $size = sizeof($minutes);
  for ($i = 0;$i < $size;$i++) {
    $total += -$minutes[$i]['minutes'] + $minutes[++$i]['minutes'];
  }
  return $total;
} //add_up_minutes()

function convert_to_decimal($total) {
  $total /= 60;
  //Correct for 12:00am
  $total = round($total, 1);
  $total = sprintf("%01.1f", $total);
  return $total;
} //convert_to_minutes()

?>
