<?php
require "./config/defaults.php";
require "./locale/$default->language/topbar.lang";
require "./lib/constants.php";
require "./lib/common_functions.php";
require "./locale/$default->language/personal_info.lang";
require "./lib/db_$default->database_driver.php";

//Check to make sure they are logged in
$sec->check_auth($authenticated);

include "./templates/common-header.inc.php";
include "./templates/topbar/topbar.inc.php";

if ($actionID == "submit") {
	if (!check_email($email)) {
		$lang->info_updated = $lang->invalid_email;
	} else {
		//Insert values into database
		$insert = oats_update_info($user_name, $default->server, addslashes($fullname), addslashes($email), addslashes($id_num), addslashes($mailbox_num), addslashes($default_job));
		check_success($insert, "database_error");
	}
} else { 
	$lang->info_updated = "";
}

//Retrieve user info 
$info = oats_get_info($user_name, $default->server);
check_success($info, "database_error");

//Build form
include "./templates/personal/begin.inc.php";
include "./templates/personal/fullname.inc.php";
include "./templates/personal/email.inc.php";
include "./templates/personal/id_num.inc.php";
if ($default->user_use_mailbox) { include "./templates/personal/mailbox_num.inc.php"; }
include "./templates/personal/default_job.inc.php";
include "./templates/personal/end.inc.php";

include "./templates/common-footer.inc.php";

?>
