# You can simply direct this file to mysql as STDIN:
# $ mysql (user/pass/host args) < mysql_create.sql

#
# Table structure for table `oats_personal_info`
#

CREATE TABLE oats_personal_info (
  user varchar(120) NOT NULL default '',
  fullname varchar(255) default NULL,
  email varchar(120) default NULL,
  id_num varchar(30) default NULL,
  mailbox_num varchar(30) default NULL,
  default_job varchar(30) default NULL,
  PRIMARY KEY  (user)
) TYPE=MyISAM;

#
# Table structure for table `oats_jobs`
#

CREATE TABLE oats_jobs (
  user varchar(120) NOT NULL default '',
  job_name varchar(255) NOT NULL default '',
  account_num varchar(50) default NULL,
  supervisor varchar(255) default NULL,
  supervisor_email varchar(120) default NULL,
  department varchar(255) default NULL,
  employment_type varchar(30) default NULL,
  fill_in_hours char(3) default NULL,
  payrate float default NULL,
  UNIQUE KEY job_name (job_name)
) TYPE=MyISAM;

#
# Table structure for table `oats_faq`
#

CREATE TABLE oats_faq (
  id int(10) unsigned NOT NULL auto_increment,
  question varchar(255) default NULL,
  answer text,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table `oats_time`
#

CREATE TABLE oats_time (
  user varchar(120) NOT NULL default '',
  day int(10) unsigned default NULL,
  job_name varchar(255) default NULL,
  minutes smallint(5) unsigned default NULL,
  sequence tinyint(3) unsigned default NULL
) TYPE=MyISAM;

#
# Table structure for table `oats_users`
#

CREATE TABLE oats_users (
  id int(10) unsigned NOT NULL auto_increment,
  user varchar(120) NOT NULL default '',
  password varchar(255) NOT NULL default '',
  lastLogin datetime NOT NULL default '0000-00-00 00:00:00',
  numLogins int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY user (user)
) TYPE=MyISAM;

# ======================================================================
# end of table definitions
#
# Create default user
#

INSERT INTO oats_users SET `user`='admin', `password`=PASSWORD('admin');

