#!/bin/sh

# This is a possible /etc/cron.daily file that will clean up
# any pdf/txt/html that are created by OATS users when a timecard is submitted
# It *really* should run only as your web user or whoever actually owns
# the files IMP creates...i.e. don't run this as root

# The full path specified in config.php where OATS will store 
# the submitted timecards (i.e. /www/timecard/print/)
OATSPRINTPATH=""
# Number of days old files should be before being deleted (default is 1 or more days)
DAYSOLD=1

### Shouldn't need to edit anything below here ###
if test "$OATSPRINTPATH" != ""
  then
  find $OATSPRINTPATH -name OATS* -atime +$DAYSOLD -type f -exec rm -f {} \;
else
  echo Usage: Edit this file and enter the path to your OATS print directory.
  echo Then you can install it in your crontab to keep it from filling up with old timecards.
  exit 1
fi
exit 0
