<?php
//Display timecard for submission
//Number of days in period is last part of $date
$parts = explode("-", $date);
$date_parts = explode("/",$parts[0]);
$num_days = $parts[1];
$end_date = date("m/d/Y", mktime(0,0,0,$date_parts[0],$date_parts[1] + $num_days,$date_parts[2]));
$num_days++;

//Calculate columns
$cols = ($default->num_of_inouts * 2) + 2;
$cols_for_total = $cols - 3;
if ($default->calculate_overtime) {
  //Change total hours heading
  $lang->total_hours = $lang->regular_hours;
  $cols++;
}
if ($default->calculate_breaks) $cols++;

$job_details = oats_get_job_details ($user_name, $default->server,addslashes($job));
check_success($job_details, "database_error");

//In order to make PDF files an actually html file has to be made
ob_start();

//See if they are work study
if ($job_details['employment_type'] != "work_study") {
  $lang->work_study = "";
} else {
  $lang->work_study = "($lang->work_study)";
}


echo "
<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\" bgcolor=\"$default->light_bg_color\" text=\"$default->dark_text_color\" align=\"center\" valign=\"top\" width=\"600\">
  <tr>
    <td align=\"center\" colspan=\"$cols\">
      <span class='header'><b>$lang->timecard_title $lang->for " . $user_info['fullname'] . " $lang->work_study</b></span>
      <br />
    </td>
  </tr>
  <tr>
    <td colspan=" . ($cols / 2) . ">
      <b>$lang->start_date</b>: $parts[0]
    </td>
    <td align=\"right\" colspan=\"" . round(($cols / 2)) . "\">
      <b>$lang->end_date</b>: $end_date
    </td>
  </tr>
  <tr>
    <td colspan=" . ($cols / 2) . ">
      <b>$lang->id_num</b>: " . $user_info['id_num'] . "
    </td>";
if ($default->user_use_mailbox) {
  echo "
    <td align='right' colspan=" . round(($cols / 2)) . ">
      <b>$lang->mb_num</b>: ${user_info['mailbox_num']}
    </td>";
} else { 
  echo "
    <td colspan=" . ($cols / 2) . ">&nbsp;</td>"; 
}
echo "
  </tr>
  <tr>
    <td colspan=" . ($cols / 2) . ">
      <b>$lang->job_title</b>: $job
    </td>
    <td align=\"right\" colspan=\"" . round(($cols / 2)) . "\">
      <b>$lang->sup_name</b>: ${job_details['supervisor']}
    </td>
  </tr>
  <tr>
    <td colspan=\"" . ($cols / 2) . "\">
      <b>$lang->dept_name</b>: ${job_details['department']}
    </td>
    <td align=\"right\" colspan=\"" . round(($cols / 2)) . "\">
      <b>$lang->acct_num</b>: ${job_details['account_num']}
    </td>
  </tr>";

$ot_hours = 0;
for ($day_num = 0; $day_num < $num_days; $day_num++) {
  $new_time = mktime(0,0,0,$date_parts[0],$date_parts[1] + $day_num,$date_parts[2]);

  //If it's the beginning of the week or it hasn't been done once print week and col labels 
  if (strcasecmp($default->week_start, date("l", $new_time)) == 0 || !$printed_first_week) {
    $week++;
    print_week($week, $cols);
    $text_day .= print_week($week, $cols, true);
    print_col_labels(true);
    $text_day .= print_col_labels(true, true);
    $printed_first_week = true;
  }

  //Get total amount of time for each week
  $minutes = oats_get_times($user_name,$default->server,$new_time,addslashes($job));
  check_success($minutes,"database_error");
  $total = add_up_minutes($minutes);
  //Check for in time, but no out time
  if ($total < 0) $show_explanation = true;

  print_day($new_time, $job, false, true);
  if ($default->calculate_overtime) {
    $ot_hours = calculate_overtime($total, "day");
    //Subtract ot_hours from regular total time (ot_hours is 0 if there was no overtime)
    $total -= $ot_hours;
    $ot_week += $ot_hours;
  }
  //Add today's total to total time for the week
  $total_week += $total;

  //Text version
  $text_day .= print_day($new_time,$job, false, true, true);

  //If tomorrow is the week start or it is the last day
  //print the total hours for that week
  $next_month = date("m", $new_time + SECONDS_IN_DAY);
  $next_day = date("d", $new_time + SECONDS_IN_DAY);
  $next_year = date("Y", $new_time + SECONDS_IN_DAY);
  $next_time = mktime(0,0,0,$next_month,$next_day,$next_year);
  if (strcasecmp($default->week_start, date("l", $next_time)) == 0 || $day_num == ($num_days - 1)) {
    //Calculate overtime for the week
    if ($default->calculate_overtime) {
      $ot_tmp = calculate_overtime($total_week,"week");
      //Subtract ot_week from regular total time (ot_week is 0 if there was no overtime)
      $total_week -= $ot_tmp;
      //Add what they have for all the days to any for the week
      $ot_week += $ot_tmp;
      $grand_overtime += $ot_week;
      $ot_week = minutes_to_24($ot_week);
    }
    $grand_total += $total_week;
    $total_week = minutes_to_24($total_week);

    //check if negative hours were found
    if ($show_explanation) {
      $output = $lang->negative_time . ASTERISK;
    } else { 
      //Print the total hours for last week
      $output =  $total_week['hour'] . ":" . $total_week['minutes'];
    }

    for ($i = -1; $i <= $cols_for_total; $i++) {
      $text_day .= "\t";
    }
    $text_day .= "  $lang->total_hours: $output";
    echo "
  <tr>
    <td colspan=\"$cols_for_total\">&nbsp;</td>
    <td colspan=\"2\" bgcolor=\"$default->item_bg_color\" align=\"right\" nowrap=\"nowrap\">
      <b>$lang->total_hours:</b>
    </td>
    <td align=\"center\" bgcolor=\"$default->item_bg_color\">
      <b>$output</b>
    </td>";
    if ($default->calculate_overtime) {
      $output =  $ot_week['hour'] . ":" . $ot_week['minutes'];
      $text_day .= "\t\t$output";
      echo "
    <td align=\"center\" bgcolor=\"$default->item_bg_color\">
      <b>$output</b>
    </td>";
       unset($ot_week);
     }
     if ($default->calculate_breaks) {
       echo "
    <td align=\"center\" bgcolor=\"$default->item_bg_color\">&nbsp;</td>\n";
     }
     $text_day .= "\n";
     echo "
  </tr>";
     unset($total_week);
  }
} 

//Output grand total
//check if negative hours were found
if ($show_explanation) {
  $output = $lang->negative_time . ASTERISK;
} else {
  //Grand total
  $grand_total = minutes_to_24($grand_total);
  $output = $grand_total['hour'] . ":" . $grand_total['minutes'];
}

for ($i = -1; $i <= $cols_for_total; $i++) {
  $text_day .= "\t";
}

$text_day .= "   $lang->grand_total: $output";
echo "
  <tr>
    <td colspan=\"$cols_for_total\">&nbsp;</td>
    <td colspan=\"2\" bgcolor=\"$default->item_bg_color\" align=\"right\" nowrap=\"nowrap\">
      <b>$lang->grand_total:</b>
    </td>
    <td align=\"center\" bgcolor=\"$default->item_bg_color\">
      <b>$output</b>
    </td>";
if ($default->calculate_overtime) {
  //Overtime grand total
  $grand_overtime = minutes_to_24($grand_overtime);
  $output = $grand_overtime['hour'] . ":" . $grand_overtime['minutes'];
  $text_day .= "\t\t$output";
  echo "
   <td align=\"center\" bgcolor=\"$default->item_bg_color\">
     <b>$output</b>
   </td>";
}
if ($default->calculate_breaks) {
 echo "<td align=\"center\" bgcolor=\"$default->item_bg_color\">&nbsp;</td>\n";
}

$text_day .= "\n";
echo "</tr>";
//output explanation
if ($show_explanation) {
  echo "
  <tr>
    <td colspan=\"$cols\" align=\"center\">
      <i>" . ASTERISK . " $lang->negative_explanation</i>
    </td>
  </tr>";
}

//Signature line
echo "
  <tr>
    <td colspan=\"$cols\">&nbsp;</td>
  </tr>
  <tr>
    <td colspan=" . ($cols / 2) . ">
      <b>__________________________</b>
    </td>
    <td align=\"right\" colspan=" . round(($cols / 2)) . ">
      <b>__________________________</b
    </td>
  </tr>
  <tr>
    <td colspan=" . ($cols / 2) . ">
      <b>${user_info['fullname']}</b>
    </td>
    <td align=\"right\" colspan=\"" . round(($cols / 2)) . "\">
      <b>${job_details['supervisor']}</b
    </td>
  </tr>";

$text_day .= "\n__________________________\n";
$text_day .= $user_info['fullname'] . "\n";
$text_day .= "\n__________________________\n";
$text_day .= $job_details['supervisor'] . "\n";

//Explanation of breaks
if ($default->calculate_breaks) {
  echo "
  <tr>
    <td colspan=\"$cols\" align=\"center\">
      <i>$lang->breaks_explanation</i>
    </td>
  </tr>";
  $text_day .= "\n$lang->breaks_explanation\n";
}
echo "
</table>";

//Create text version
$text_version = "
$lang->timecard_title $lang->for " . $user_info['fullname'] . "

$lang->start_date: $parts[0] \t $lang->end_date: $end_date
$lang->id_num: " . $user_info['id_num'];
if ($default->user_use_mailbox) {
   $text_version .= " \t\t $lang->mb_num:" . $user_info['mailbox_num'];
} 
$text_version .= "
$lang->job_title: $job \t\t $lang->sup_name: ${job_details['supervisor']}
$lang->dept_name: ${job_details['department']} \t\t $lang->acct_num: ${job_details['account_num']}\n\r\n\r";
$text_version .= $text_day;

//Write to file
$tmpfname = tempnam("", "OATS-");
$fp = fopen($tmpfname, "w");
$pathInfo = pathinfo($tmpfname);
$printfname = $pathInfo['basename'];
$pathInfo = pathinfo($_SERVER['PHP_SELF']);
$printfnameFull = dirname(__FILE__) . '/../../print/' . $printfname;
$printfname = $pathInfo['dirname'] . '/print/' . $printfname;

//Make different types of output
if ($default->print_format == 'html' || $default->print_format == 'pdf') {
  $html_header = "<html><head><title>$lang->timecard_title $lang->for " . $user_info['fullname'] . "</title></head><body bgcolor=\"$default->light_bg_color\">\n";
  fwrite($fp, $html_header);
  fwrite($fp, ob_get_contents());
  fwrite($fp, "</body></html>\n");
  fclose($fp);
    if ($default->print_format == 'pdf') {
        require_once dirname(__FILE__) . '/../../lib/HTML_ToPDF.php';

        $printfname .= '.pdf'; 
        $printfnameFull .= '.pdf'; 

        $pdf = new HTML_ToPDF($tmpfname, $_SERVER['SERVER_NAME']);
        // scale it down slightly so it fits on one page
        $pdf->setScaleFactor('.9');
        $pdf->setHtml2Ps($default->html2ps_path);
        $pdf->setPs2Pdf($default->ps2pdf_path);
        $result = $pdf->convert();

        if (PEAR::isError($result)) {
            echo $result->getMessage();
        }
        else {
            copy($result, $printfnameFull);
            unlink($result);
        }

    } else {  //just use a plain html file for printing
        $printfname .= '.htm'; 
        $printfnameFull .= '.htm'; 
        copy($tmpfname, $printfnameFull); 
    }
} else {  //Make plain text file
    fwrite ($fp, $text_version);
    fclose($fp);
    $printfname .= '.txt'; 
    $printfnameFull .= '.txt'; 
    copy ($tmpfname, $printfnameFull); 
}
unlink($tmpfname);

//End buffering and output to browser
ob_end_flush();

echo "<br /><center><a class=\"dark\" href=\"javascript: void(0);\" onClick=\"newWin('$printfname'); return false;\" onMouseOver=\"status='$lang->print_tcard'; return true;\" onMouseOut=\"status='';\">$lang->print_tcard</a>";
echo $default->print_format == "pdf" ? "<br><a href=\"javascript: void(0);\" onClick=\"newWin('http://www.adobe.com/products/acrobat/readstep.html'); return false;\"><img border=\"0\" src=\"http://www.adobe.com/images/getacro.gif\"></a>" : "";
echo "</center>\n";

//Create email buttons if they have appropriate email addresses.
echo "
<br />
<table align=\"center\" border=\"0\" cellspacing=\"6\">
  <tr>";
if (!empty($user_info['email'])) {
  $link = "email.php?email=" . urlencode($user_info['email']) . "&text_version=" . urlencode($text_version);
  $link = $sec->addSessToLink($link);
  echo "
    <td align=\"center\">
      <input type=\"button\" class=\"button\" value=\"$lang->email_user\" onClick=\"newWin2('$link'); return false;\" />
      <br />
      <small>${user_info['email']}</small>
    </td>";
}
if (!empty($job_details['supervisor_email'])) {
  $link = "email.php?email=" . urlencode($job_details['supervisor_email']) . "&text_version=" . urlencode($text_version);
  $link = $sec->addSessToLink($link);
  echo "
  <td align=\"center\">
    <input type=\"button\" class=\"button\" value=\"$lang->email_sup\" onClick=\"newWin2('$link'); return false;\" />
    <br />
    <small>${job_details['supervisor_email']}</small>
  </td>";
}
echo "
  </tr>
</table>";
?>
<script language="JavaScript">
<!--
function newWin(url) {
  var newWinParams = "location=yes,directories=no,scrollbars=yes,resizable=yes,toolbar=yes,menubar=yes,status=yes,width=640,height=450,screenX=50,screenY=25,left=50,top=25";
  window.open(url,'newWin',newWinParams);
}

function newWin2(url) {
  var newWin2Params = "location=no,directories=no,scrollbars=no,resizable=yes,toolbar=no,menubar=no,status=no,width=400,height=150,screenX=50,screenY=50,left=50,top=50";
  window.open(url,'newWin2',newWin2Params);
}
//-->
</script>
