<?php
require "./config/defaults.php";
require "./locale/$default->language/topbar.lang";
require "./lib/constants.php";
require "./lib/common_functions.php";
require "./locale/$default->language/timecard.lang";
require "./locale/$default->language/errors.lang";
require "./lib/db_$default->database_driver.php";
require "./lib/tc_functions.php";

//Check to make sure they are logged in
$sec->check_auth($authenticated);

//Make sure they have at least one job
$jobs = oats_get_jobs ($user_name, $default->server);
check_success($jobs, "database_error");
if (sizeof($jobs) == 1) {
    $location = $sec->addSessToLink("jobs.php?actionID=add");
    header("HTTP/1.0 301");
    header("Location: $location");
    exit;
}
//Make sure they have name at least
$user_info = oats_get_info($user_name, $default->server);
check_success($user_info, "database_error");
if (empty($user_info['fullname'])) {
    $location = $sec->addSessToLink("personal_info.php");
    header("HTTP/1.0 301");
    header("Location: $location");
    exit;
}
//Register the start date if it's been set
if (isset($date)) {
    list($registered_start_date,$junk) = explode("-", $date);
    $registered_start_date = strtotime($registered_start_date);
    $_SESSION['registered_start_date'] = $registered_start_date;
}

include "./templates/common-header.inc.php";
include "./templates/topbar/topbar.inc.php";

if ($actionID == "make_template") {
    //record template
    $result = process_data($tcdata, $user_name, $job_name, $job_details, true);
    //record hours as well
    $result = process_data($tcdata, $user_name, $job_name, $job_details);
    include "./templates/timecard/input_results.inc.php";
} elseif ($actionID == "load_template") {
    //set template variable
    $load_template = true;
    include "./templates/timecard/displaytc.inc.php";
} elseif ($actionID == "displaytc") {
    include "./templates/timecard/displaytc.inc.php";
} elseif ($actionID == "insert_data") {
    $job_details = oats_get_job_details($user_name, $default->server, addslashes($job_name));
    check_success($job_details, "database_error");
    $result = process_data($tcdata, $user_name, $job_name, $job_details);
    $lang->template_success = "";
    include "./templates/timecard/input_results.inc.php";
} elseif ($actionID == "clock_in_out") {
    include "./templates/timecard/clock_in_out.inc.php";
} elseif ($actionID == "submittc") {
    include "./templates/timecard/submittc.inc.php";
} else {
    include "./templates/timecard/options_screen.inc.php";
}

include "./templates/common-footer.inc.php";
?>
