<?php
require_once './config/defaults.php';
require_once "./locale/$default->language/topbar.lang";
require_once './lib/constants.php';
require_once "./lib/db_$default->database_driver.php";
require_once './lib/common_functions.php';
require_once "./locale/$default->language/user.lang.php";

// make sure they should be able to access this page
//Make sure they are an admin
$_verifiedAdmin = false;
foreach ($default->administrators as $admin) {
    if ($user_name == $admin) {
        $_SESSION['_verifiedAdmin'] = $_verifiedAdmin = true;
    }
}
if ($default->auth_method != 'db' ||
    (!$default->auth_allow_create &&
    !$_SESSION['_verifiedAdmin'])) {
    header('Location: login.php');
}

while (true) {
    switch ($actionID) {
        // {{{ USER_ADD

        case USER_ADD:
            $defaults['actionID'] = USER_SUBMIT_ADD;
            $lang->title = $lang->create_account;
            $lang->submit_user = $lang->add_user;
            // see if we're an admin
            if ($_SESSION['_verifiedAdmin']) {
                $sec->check_auth($_SESSION['authenticated']);
                $showTopbar = true;
            }
            break 2;

        // }}}
        // {{{ USER_SUBMIT_ADD

        case USER_SUBMIT_ADD:
            if ($_SESSION['_verifiedAdmin']) {
                $sec->check_auth($_SESSION['authenticated']);
            }
            $result = oats_check_user_exists($_POST['new_user']);
            if ($result) {
                // user already exists
                $lang->error_flag = sprintf($lang->already_exists, $_POST['new_user']); 
                $actionID = USER_ADD;
                break;
            }
            $result = oats_add_user($_POST['new_user'], $_POST['password']);
            check_success($result, 'database_error');
            if ($_SESSION['_verifiedAdmin']) {
                $lang->error_flag = sprintf($lang->user_added, $_POST['new_user']);
                $actionID = USER_ADD;
                break;
            }
            else {
                header('Location: ./login.php?actionID='.LOGIN_USER_ADDED.'&newuser='.$_POST['new_user']);
                exit;
            }

        // }}}
        // {{{ USER_SUBMIT_EDIT

        case USER_SUBMIT_EDIT:
            $sec->check_auth($_SESSION['authenticated']);
            $showTopbar = true;
            $result = oats_change_password($_POST['new_user'], $_POST['password']);
            check_success($result, 'database_error');
            $lang->error_flag = $lang->password_updated;
            $actionID = USER_CHANGE_PASSWORD;
            break;

        // }}}
        // {{{ USER_CHANGE_PASSWORD

        case USER_CHANGE_PASSWORD:
            $sec->check_auth($_SESSION['authenticated']);
            $showTopbar = true;
            $defaults['actionID'] = USER_SUBMIT_EDIT;
            $defaults['new_user'] = $_SESSION['user_name'];
            $lang->title = $lang->change_password;
            $lang->submit_user = $lang->update;
            break 2;

        // }}}
        // {{{ default

        default:
            $actionID = USER_ADD;
            break;

        // }}}
    }
}

include_once './templates/common-header.inc.php';
if ($showTopbar) {
    include_once './templates/topbar/topbar.inc.php';
}
include_once './templates/user/user.inc.php';
include_once './templates/common-footer.inc.php';
?>
